#include "olcPGEX_Graphics2D.h"
#include "olcPGEX_Sound.h"
#include "olcPixelGameEngine.h"
#include <cstdint>
#include <iostream>

namespace pabloader {
class Awoorwae;

class Entity {
protected:
    Awoorwae* game;
    olc::Sprite img;
    olc::GFX2D::Transform2D transform;
    float x, y;
    float xv, yv;
    int w, h;
    int tile = 0;
    int skin = 0;
    int tileCounter = 0;
    bool onGround = false;

public:
    Entity(Awoorwae* game_);
    virtual ~Entity(){};

    virtual olc::rcode Load() = 0;
    virtual void Update(float dt) = 0;
    virtual void Draw() = 0;
};

class Player : public Entity {
public:
    Player(Awoorwae* game);
    olc::rcode Load() override;
    void Update(float dt) override;
    void Draw() override;
};

class Awoorwae : public olc::PixelGameEngine {
private:
    Player* player;

public:
    Awoorwae()
    {
        sAppName = "Awoorwa";
        player = new Player(this);
    }

    ~Awoorwae()
    {
        delete player;
    }

public:
    bool OnUserCreate() override;
    bool OnUserUpdate(float fElapsedTime) override;
};
}